#ifndef ImgFltAux
#define ImgFltAux

#include <math.h>
//#include <fstream>
//#include <iostream>
//using namespace std;

/* Memory Related functions */

template <class T>
void SwapBuffer(T *buf0, T *buf1, int size)
{
	while (size>0)
	{
		T tmp;
		
		tmp = *buf0;
		*buf0 = *buf1;
		*buf1 = tmp;

		buf0++;
		buf1++;

		size--;
	}
}

template <class T>
void VerticalFlipBuffer(T *buf,int width, int height)
{
	T *top = buf + (height-1)*width;
	T *bottom = buf;

	while (top > bottom)
	{
		SwapBuffer(top,bottom,width);
		top -= width;
		bottom += width;
	}
}



#endif