#ifndef CONVOLVE_H
#define CONVOLVE_H

#include "imgflt.h"

void image_filter(double *rsltImg, const double *origImg, const unsigned char *selection, 
			int imgWidth, int imgHeight, 
			const double *kernel, int knlWidth, int knlHeight,
			double scale, double offset); 

void pixel_filter(double rsltPixel[3], int x, int y, const double *origImg, int imgWidth, int imgHeight, 
			const double *kernel, int knlWidth, int knlHeight,
			double scale, double offset);

void image_filter_helper(double *rsltImg, const double *origImg, 
			  int imgWidth, int imgHeight, 
			  const double *kernel, int knlWidth, int knlHeight,
			  double scale, double offset); 

void image_filter_helper(double *rsltImg, const double *origImg, const unsigned char *selection, 
			  int imgWidth, int imgHeight, 
			  const double *kernel, int knlWidth, int knlHeight,
			  double scale, double offset); 

#endif